=== modified file 'Makefile'
--- Makefile	2011-06-28 15:29:03 +0000
+++ Makefile	2011-06-29 16:57:56 +0000
@@ -182,13 +182,12 @@
 # its jsTestDriver test harness modifications in the lazr.js and
 # launchpad.js roll-up files.  They fiddle with built-in functions!
 # See Bug 482340.
-jsbuild_yui: bin/jsbuild
+jsbuild_minify: bin/jsbuild
 	${SHHH} bin/jsbuild \
 	    --builddir $(LAZR_BUILT_JS_ROOT) \
-	    --exclude testing/ --filetype $(JS_BUILD) \
-	    --copy-yui-to $(LAZR_BUILT_JS_ROOT)/yui
+	    --exclude testing/ --filetype $(JS_BUILD)
 
-$(JS_YUI) $(JS_LAZR): jsbuild_yui
+$(JS_YUI) $(JS_LAZR): jsbuild_minify
 
 $(JS_OUT): $(JS_ALL)
 ifeq ($(JS_BUILD), min)
@@ -197,7 +196,7 @@
 	cat $^ > $@
 endif
 
-jsbuild: $(JS_OUT)
+jsbuild: $(PY) $(JS_OUT)
 
 eggs:
 	# Usually this is linked via link-external-sourcecode, but in
@@ -483,6 +482,6 @@
 	test_build test_inplace pagetests check schema default \
 	launchpad.pot pull_branches scan_branches sync_branches	\
 	reload-apache hosted_branches check_mailman check_config \
-	jsbuild jsbuild_lazr clean_js clean_buildout buildonce_eggs \
+	jsbuild jsbuild_minify clean_js clean_buildout buildonce_eggs \
 	build_eggs sprite_css sprite_image css_combine compile \
 	check_schema pydoctor clean_logs 

=== modified file 'buildout.cfg'
--- buildout.cfg	2011-06-28 16:48:20 +0000
+++ buildout.cfg	2011-06-29 17:29:09 +0000
@@ -3,6 +3,7 @@
 
 [buildout]
 parts =
+    yui
     scripts
     filetemplates
     tags
@@ -33,6 +34,15 @@
 [configuration]
 instance_name = development
 
+[yui]
+recipe = plone.recipe.command
+command =
+    mkdir -p download-cache/../yui-${versions:yui} && \
+    tar -zxf download-cache/yui-${versions:yui}.tar.gz \
+        -C download-cache/../yui-${versions:yui} && \
+    mkdir lazr-js/build && \
+    ln -s ../../download-cache/../yui-${versions:yui}/yui lazr-js/build/yui
+
 [filetemplates]
 recipe = z3c.recipe.filetemplate
 source-directory = buildout-templates

=== added file 'lib/lp/scripts/utilities/build/jsmin.py'
--- lib/lp/scripts/utilities/build/jsmin.py	1970-01-01 00:00:00 +0000
+++ lib/lp/scripts/utilities/build/jsmin.py	2011-06-29 15:52:02 +0000
@@ -0,0 +1,218 @@
+#!/usr/bin/python
+
+# This code is original from jsmin by Douglas Crockford, it was translated to
+# Python by Baruch Even. The original code had the following copyright and
+# license.
+#
+# /* jsmin.c
+#    2007-05-22
+#
+# Copyright (c) 2002 Douglas Crockford  (www.crockford.com)
+#
+# Permission is hereby granted, free of charge, to any person obtaining a copy of
+# this software and associated documentation files (the "Software"), to deal in
+# the Software without restriction, including without limitation the rights to
+# use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
+# of the Software, and to permit persons to whom the Software is furnished to do
+# so, subject to the following conditions:
+#
+# The above copyright notice and this permission notice shall be included in all
+# copies or substantial portions of the Software.
+#
+# The Software shall be used for Good, not Evil.
+#
+# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
+# SOFTWARE.
+# */
+
+from StringIO import StringIO
+
+def jsmin(js):
+    ins = StringIO(js)
+    outs = StringIO()
+    JavascriptMinify().minify(ins, outs)
+    str = outs.getvalue()
+    if len(str) > 0 and str[0] == '\n':
+        str = str[1:]
+    return str
+
+def isAlphanum(c):
+    """return true if the character is a letter, digit, underscore,
+           dollar sign, or non-ASCII character.
+    """
+    return ((c >= 'a' and c <= 'z') or (c >= '0' and c <= '9') or
+            (c >= 'A' and c <= 'Z') or c == '_' or c == '$' or c == '\\' or (c is not None and ord(c) > 126));
+
+class UnterminatedComment(Exception):
+    pass
+
+class UnterminatedStringLiteral(Exception):
+    pass
+
+class UnterminatedRegularExpression(Exception):
+    pass
+
+class JavascriptMinify(object):
+
+    def _outA(self):
+        self.outstream.write(self.theA)
+    def _outB(self):
+        self.outstream.write(self.theB)
+
+    def _get(self):
+        """return the next character from stdin. Watch out for lookahead. If
+           the character is a control character, translate it to a space or
+           linefeed.
+        """
+        c = self.theLookahead
+        self.theLookahead = None
+        if c == None:
+            c = self.instream.read(1)
+        if c >= ' ' or c == '\n':
+            return c
+        if c == '': # EOF
+            return '\000'
+        if c == '\r':
+            return '\n'
+        return ' '
+
+    def _peek(self):
+        self.theLookahead = self._get()
+        return self.theLookahead
+
+    def _next(self):
+        """get the next character, excluding comments. peek() is used to see
+           if an unescaped '/' is followed by a '/' or '*'.
+        """
+        c = self._get()
+        if c == '/' and self.theA != '\\':
+            p = self._peek()
+            if p == '/':
+                c = self._get()
+                while c > '\n':
+                    c = self._get()
+                return c
+            if p == '*':
+                c = self._get()
+                while 1:
+                    c = self._get()
+                    if c == '*':
+                        if self._peek() == '/':
+                            self._get()
+                            return ' '
+                    if c == '\000':
+                        raise UnterminatedComment()
+
+        return c
+
+    def _action(self, action):
+        """do something! What you do is determined by the argument:
+           1   Output A. Copy B to A. Get the next B.
+           2   Copy B to A. Get the next B. (Delete A).
+           3   Get the next B. (Delete B).
+           action treats a string as a single character. Wow!
+           action recognizes a regular expression if it is preceded by ( or , or =.
+        """
+        if action <= 1:
+            self._outA()
+
+        if action <= 2:
+            self.theA = self.theB
+            if self.theA == "'" or self.theA == '"':
+                while 1:
+                    self._outA()
+                    self.theA = self._get()
+                    if self.theA == self.theB:
+                        break
+                    if self.theA <= '\n':
+                        raise UnterminatedStringLiteral()
+                    if self.theA == '\\':
+                        self._outA()
+                        self.theA = self._get()
+
+
+        if action <= 3:
+            self.theB = self._next()
+            if self.theB == '/' and (self.theA == '(' or self.theA == ',' or
+                                     self.theA == '=' or self.theA == ':' or
+                                     self.theA == '[' or self.theA == '?' or
+                                     self.theA == '!' or self.theA == '&' or
+                                     self.theA == '|' or self.theA == ';' or
+                                     self.theA == '{' or self.theA == '}' or
+                                     self.theA == '\n'):
+                self._outA()
+                self._outB()
+                while 1:
+                    self.theA = self._get()
+                    if self.theA == '/':
+                        break
+                    elif self.theA == '\\':
+                        self._outA()
+                        self.theA = self._get()
+                    elif self.theA <= '\n':
+                        raise UnterminatedRegularExpression()
+                    self._outA()
+                self.theB = self._next()
+
+
+    def _jsmin(self):
+        """Copy the input to the output, deleting the characters which are
+           insignificant to JavaScript. Comments will be removed. Tabs will be
+           replaced with spaces. Carriage returns will be replaced with linefeeds.
+           Most spaces and linefeeds will be removed.
+        """
+        self.theA = '\n'
+        self._action(3)
+
+        while self.theA != '\000':
+            if self.theA == ' ':
+                if isAlphanum(self.theB):
+                    self._action(1)
+                else:
+                    self._action(2)
+            elif self.theA == '\n':
+                if self.theB in ['{', '[', '(', '+', '-']:
+                    self._action(1)
+                elif self.theB == ' ':
+                    self._action(3)
+                else:
+                    if isAlphanum(self.theB):
+                        self._action(1)
+                    else:
+                        self._action(2)
+            else:
+                if self.theB == ' ':
+                    if isAlphanum(self.theA):
+                        self._action(1)
+                    else:
+                        self._action(3)
+                elif self.theB == '\n':
+                    if self.theA in ['}', ']', ')', '+', '-', '"', '\'']:
+                        self._action(1)
+                    else:
+                        if isAlphanum(self.theA):
+                            self._action(1)
+                        else:
+                            self._action(3)
+                else:
+                    self._action(1)
+
+    def minify(self, instream, outstream):
+        self.instream = instream
+        self.outstream = outstream
+        self.theA = '\n'
+        self.theB = None
+        self.theLookahead = None
+
+        self._jsmin()
+        self.instream.close()
+
+if __name__ == '__main__':
+    import sys
+    jsm = JavascriptMinify()
+    jsm.minify(sys.stdin, sys.stdout)

=== modified file 'lib/lp/scripts/utilities/js/jsbuild.py'
--- lib/lp/scripts/utilities/js/jsbuild.py	2011-06-28 16:48:20 +0000
+++ lib/lp/scripts/utilities/js/jsbuild.py	2011-06-29 17:29:09 +0000
@@ -17,9 +17,7 @@
 
 HERE = os.path.dirname(__file__)
 BUILD_DIR = os.path.normpath(os.path.join(HERE, '..', '..', '..', 'build'))
-DEFAULT_SRC_DIR = os.path.normpath(os.path.join(HERE, '..', '..', '..'))
-PKG_SRC_DIR = pkg_resources.resource_filename(
-    pkg_resources.Requirement.parse("lazr-js"), "lazrjs")
+DEFAULT_SRC_DIR = os.path.normpath(os.path.join(HERE, '..', '..', '..', 'app', 'javascript'))
 
 ESCAPE_STAR_PROPERTY_RE = re.compile(r'\*([a-zA-Z0-9_-]+):')
 UNESCAPE_STAR_PROPERTY_RE = re.compile(r'([a-zA-Z0-9_-]+)_ie_star_hack:')
@@ -189,9 +187,8 @@
 
 class Builder:
 
-    def __init__(self, name='lazr', build_dir=BUILD_DIR, src_dir=PKG_SRC_DIR,
-                 extra_files=None, exclude_regex='', file_type='raw',
-                 copy_yui_to=BUILD_DIR):
+    def __init__(self, name='lazr', build_dir=BUILD_DIR, src_dir=DEFAULT_SRC_DIR,
+                 extra_files=None, exclude_regex='', file_type='raw'):
         """Create a new Builder.
 
         :param name: The name of the package we are building. This will
@@ -207,8 +204,6 @@
             file.  Possible values are 'raw', 'min', and 'debug'.  File types
             are identified by their basename suffix: foo.js, foo-min.js,
             foo-debug.js, etc.
-        :param copy_yui_to: The absolute path (as a string) to the place where
-            the YUI modules should be copied to. Defaults to BUILD_DIR.
         """
         self.name = name
         self.build_dir = build_dir
@@ -227,7 +222,6 @@
 
         self.exclusion_regex = exclude_regex
         self.file_type = file_type
-        self.copy_yui_to = copy_yui_to
 
         self.log("Using filter: " + self.file_type)
 
@@ -417,17 +411,7 @@
                 continue
             yield name, path
 
-    def copy_yui_package(self):
-        """Copy the contents of our 'yui' dir to self.copy_yui_to."""
-        yui_dirs = glob(os.path.join(self.src_dir, 'yui') + '/*')
-        for dir in yui_dirs:
-            dir_name = os.path.split(dir)[-1]
-            dst_dir = os.path.join(self.copy_yui_to, dir_name)
-            if not os.path.isdir(dst_dir):
-                shutil.copytree(dir, dst_dir)
-
     def do_build(self):
-        self.copy_yui_package()
         for name, cpath in self.find_components():
             files_to_link = glob(os.path.join(cpath, '*.js'))
             if len(files_to_link) == 0:
@@ -458,7 +442,7 @@
         '-b', '--builddir', dest='build_dir', default=BUILD_DIR,
         help=('The directory that should contain built files.'))
     parser.add_option(
-        '-s', '--srcdir', dest='src_dir', default=PKG_SRC_DIR,
+        '-s', '--srcdir', dest='src_dir', default=DEFAULT_SRC_DIR,
         help=('The directory containing the src files.'))
     parser.add_option(
         '-x', '--exclude', dest='exclude', default='',
@@ -469,20 +453,17 @@
         help=('Only bundle files in the source directory that match the '
               'specified file-type filter. Possible values are '
               '[min, raw, debug]. [default: %default]'))
-    parser.add_option(
-        '-c', '--copy-yui-to', dest='copy_yui_to', default=BUILD_DIR,
-        help=('Copy the YUI tree to the given directory before building'))
     return parser.parse_args()
 
 
 def main():
-   options, extra= get_options()
-   Builder(
+    options, extra= get_options()
+
+    Builder(
        name=options.name,
        build_dir=options.build_dir,
        src_dir=options.src_dir,
        extra_files=extra,
        exclude_regex=options.exclude,
        file_type=options.file_type,
-       copy_yui_to=options.copy_yui_to,
        ).do_build()

=== modified file 'versions.cfg'
--- versions.cfg	2011-06-27 23:06:19 +0000
+++ versions.cfg	2011-06-29 16:57:56 +0000
@@ -50,6 +50,7 @@
 paramiko = 1.7.4
 Paste = 1.7.2
 PasteDeploy = 1.3.3
+plone.recipe.command = 1.1
 psycopg2 = 2.2.2
 pyasn1 = 0.0.9a
 pycrypto = 2.0.1
@@ -87,6 +88,7 @@
 wsgi-jsonrpc = 0.2.8
 wsgi-xmlrpc = 0.2.7
 wsgiref = 0.1.2
+yui = 3.3
 z3c.coverage = 1.1.2
 z3c.csvvocabulary = 1.0.0
 z3c.etestbrowser = 1.0.4

